package com.huawei.iotplatform.utils;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

public class AesUtil {
	/**
     * AES encrypted character string
     * @param content Character string to be encrypted
     * @param password Password for encryption
     * @return Encrypted text
     */
    public static byte[] encrypt(String content, String password) {
        try {
            KeyGenerator kgen = KeyGenerator.getInstance("AES");// Key producer who created the AES.
            kgen.init(128, new SecureRandom(password.getBytes()));// Generate a random source of 128 bits.
            SecretKey secretKey = kgen.generateKey();// Generate a private key based on the user password.
            byte[] enCodeFormat = secretKey.getEncoded();//  Return the private key in the basic encoding format. If the key does not support encoding, null is returned.
            SecretKeySpec key = new SecretKeySpec(enCodeFormat, "AES");// Convert to AES private key.
            Cipher cipher = Cipher.getInstance("AES");// Create a cipher.
            byte[] byteContent = content.getBytes("utf-8");
            cipher.init(Cipher.ENCRYPT_MODE, key);// Cipher that is initialized to the encryption mode
            byte[] result = cipher.doFinal(byteContent);// encryption
            return result;

        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        }
        return null;
    }
    
    /**
     * Decrypt the character string encrypted using the AES algorithm.
     * 
     * @param content Content encrypted using the AES algorithm.
     * @param password Password for encryption
     * @return Plain text
     */
    public static byte[] decrypt(byte[] content, String password) {
        try {
            KeyGenerator kgen = KeyGenerator.getInstance("AES");// Key producer who created the AES.
            kgen.init(128, new SecureRandom(password.getBytes()));
            SecretKey secretKey = kgen.generateKey();// Generate a private key based on the user password.
            byte[] enCodeFormat = secretKey.getEncoded();//  Return the private key in the basic encoding format.
            SecretKeySpec key = new SecretKeySpec(enCodeFormat, "AES");// Convert to AES private key.
            Cipher cipher = Cipher.getInstance("AES");// Create a cipher.
            cipher.init(Cipher.DECRYPT_MODE, key);// Cipher that is initialized to the decryption mode
            byte[] result = cipher.doFinal(content);  
            return result; // Plain text   
            
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        }
        return null;
    }
}
